%define phpversion 4.0.4pl1
%define phprelease 6mdk
%define phpdir %{_libdir}/php 
%define phpsource /usr/src/php-devel

Summary:	Readline module for PHP4
Name:		php-readline
Version:	%{phpversion}
Release:	6mdk
Group:		System/Servers
Copyright:	PHP License
BuildRoot:	%{_tmppath}/%{name}-root
Prereq:		php-common = %{phpversion}, perl
Requires:	readline >= 4.1, libncurses5 >= 5.2
BuildRequires:  php-devel = %{phpversion}
BuildRequires:	readline-devel >= 4.1, libncurses5-devel >= 5.2 
Obsoletes:	mod_php-readline

%description
The php-readline package is a dynamic shared object (DSO) that adds readline
support to PHP4. The "readline" library will read a line from the terminal
and return it, allowing the user to edit the line with the standard emacs
editing keys. It allows the programmer to give the user an easier-to-use and
more intuitive interface. PHP4 is an HTML-embedded scripting language. If
you need readline support for PHP4 applications, you will need to install
this package in addition to the php package.

%build
[ -e ./readline ] && rm -fr ./readline
cp -dpR %{phpsource}/extensions/readline .
cd readline

%{phpsource}/buildext readline readline.c \
	"-lreadline -lhistory -lncurses" \
        "-DCOMPILE_DL_READLINE -DHAVE_LIBREADLINE -DCGI_BINARY"

%install
cd readline
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT 
mkdir -p $RPM_BUILD_ROOT%{phpdir}/extensions

install -m 755 -s readline.so $RPM_BUILD_ROOT%{phpdir}/extensions/

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
echo > $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/README <<EOF
The php-readline package contains a dynamic shared object (DSO) for PHP4. 
To activate it, make sure the line 'extension=readline.so' is uncommented
in your /etc/php.ini file.
EOF

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
[ -e ./readline ] && rm -fr ./readline

%post
if [ $1 = "1" ]; then
  if [ -f %{_sysconfdir}/php.ini ]; then
    perl -pi -e 's|^;extension\s*=\s*readline.so|extension = readline.so|' %{_sysconfdir}/php.ini
  fi
fi
if [ $1 -gt 1 ]; then
   #We're in *upgrade mode*. Since we can't be sure the configuration files
   #are sane, remove module from the conf files to clean them, re-add again
   #in a way that the older module we're replacing won't try to erase (the
   #post scripts were broken on some packages)
   #Also, there could be extra lines, so make sure we uncomment one
   #Finally, don't check for presence of php.ini, if it's not there,
   #we have a problem, so it should generate an error message.
   perl -pi -e 's|^extension\s*=\s*readline.so|;extension = readline.so|g' %{_sysconfdir}/php.ini
   perl -pi -e 's|^;extension\s*=\s*readline.so|extension = readline.so|' %{_sysconfdir}/php.ini
fi
if [ -e %{_sbindir}/AESctl ]; then %{_sbindir}/AESctl update;fi 

%preun
if [ $1 = "0" ]; then
  if [ -f %{_sysconfdir}/php.ini ]; then
    perl -pi -e 's|^extension\s*=\s*readline.so|;extension = readline.so|g' %{_sysconfdir}/php.ini
  fi
  if [ -e %{_sbindir}/AESctl ]; then %{_sbindir}/AESctl update;fi 
fi

%files 
%defattr(-,root,root)
%{phpdir}/extensions/readline.so
%dir %{_docdir}/%{name}-%{version}
%{_docdir}/%{name}-%{version}/README

%changelog
* Thu Apr 12 2001 Jean-Michel Dault <jmdault@mandrakesoft.com> 4.0.4pl1-6mdk
- fix requires

* Mon Apr  9 2001 Jean-Michel Dault <jmdault@mandrakesoft.com> 4.0.4pl1-5mdk
- fix post scripts for good 

* Mon Apr  2 2001 Jean-Michel Dault <jmdault@mandrakesoft.com> 4.0.4pl1-4mdk
- Split readline package from php package so that when a new readline 
  package comes out, we don't have to recompile php, only this module
